/*

Copyright 2003 The University of New South Wales (UNSW) and National  
ICT Australia (NICTA).

This file is part of the 2003 team rUNSWift RoboCup entry.  You may  
redistribute it and/or modify it under the terms of the GNU General  
Public License as published by the Free Software Foundation; either  
version 2 of the License, or (at your option) any later version as  
modified below.  As the original licensors, we add the following  
conditions to that license:

In paragraph 2.b), the phrase "distribute or publish" should be  
interpreted to include entry into a competition, and hence the source  
of any derived work entered into a competition must be made available  
to all parties involved in that competition under the terms of this  
license.

In addition, if the authors of a derived work publish any conference  
proceedings, journal articles or other academic papers describing that  
derived work, then appropriate academic citations to the original work  
must be included in that publication.

This rUNSWift source is distributed in the hope that it will be useful,  
but WITHOUT ANY WARRANTY; without even the implied warranty of  
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
General Public License for more details.

You should have received a copy of the GNU General Public License along  
with this source code; if not, write to the Free Software Foundation,  
Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

//image classification program for robocup 2001
//author: tomv@cse.unsw.edu.au
//this program is used to calibrate the color table for the dogs
//by manually selecting regions of color for each of 8 C values

import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.*;
import javax.swing.SwingUtilities;
import java.io.*;

/**
 *  Description of the Class
 *
 * @author     rsheh
 * @created    18 December 2002
 */
public class ic extends JFrame
{

	static               boolean       packFrame       = false;

	                     JPanel        contentPane;

	public final static  int           PIC_WIDTH       = BFLPanel.PIC_WIDTH;
	public final static  int           PIC_HEIGHT      = BFLPanel.PIC_HEIGHT;

	                     int           startRGB        = 0;
	//the starting colour for the magic wand
	                     int           startR;
	                     int           startG;
	                     int           startB;

	                     int           lineX           = -1;
	//the start points for the line tool
	                     int           lineY           = -1;

	                     int           threshold       = 25;
	//the threshold for the magic wand

											 File          currentFile     = null;

	                     String        selectedTool    = "brush";
	//the color that the edges will be marked in (RGB)
	                     int           edgeColor       = Color.RED.getRGB();

	                     BFLPanel      jPanel1         = new BFLPanel();
											 int           edgeArray[][]   = new int[PIC_HEIGHT][PIC_WIDTH];
											 int           prevRGBPlane[][] = new int[PIC_WIDTH][PIC_HEIGHT];
	public static double                  edgeWeight[]    = {1.0, 1.0, 1.0};
	public static int           			 edgeThreshold   = 150;

	                     JPanel        northPanel      = new JPanel();

	                     JRadioButton jRadioButtonOrange        = new JRadioButton();
	                     JRadioButton jRadioButtonBlue          = new JRadioButton();
	                     JRadioButton jRadioButtonGreen         = new JRadioButton();
	                     JRadioButton jRadioButtonYellow        = new JRadioButton();
	                     JRadioButton jRadioButtonPink          = new JRadioButton();
	                     JRadioButton jRadioButtonBlueDog       = new JRadioButton();
	                     JRadioButton jRadioButtonRedDog        = new JRadioButton();
	                     JRadioButton jRadioButtonGreenField    = new JRadioButton();
	                     JRadioButton jRadioButtonRobotGrey     = new JRadioButton();
	                     JRadioButton jRadioButtonFieldWhite    = new JRadioButton();
                         JRadioButton jRadioButtonBlack         = new JRadioButton(); 
                         JRadioButton jRadioButtonNone          = new JRadioButton();

	                     JMenuBar      jMenuBar1       = new JMenuBar();
	                     JFileChooser  jFileChooser1   = new JFileChooser();
	                     JPanel        jPanel2         = new JPanel();
											 JPanel        southPanel      = new JPanel();

	// Group for the radio buttons.
	                     ButtonGroup   group           = new ButtonGroup();

	protected            JToolBar      jToolBar1       = new JToolBar();
	                     JTextArea     jTextArea1      = new JTextArea();
											 JLabel        jToolLabel      = new JLabel("Tools");

	                     JButton       wandButton      = new JButton();
	                     JButton       zoombutton      = new JButton();
											 JButton       undoButton      = new JButton();

	                     JButton       fillButton      = new JButton();
	                     JTextField    jTextField1     = new JTextField();
	                     JTextField    brushField      = new JTextField();
	                     JButton       clearButton     = new JButton();
	                     JButton       lineButton      = new JButton();
	                     JButton       saveButton      = new JButton();
											 JButton       nextButton      = new JButton();
	                     JButton       paintButton     = new JButton();
	                     JButton       jButton1        = new JButton();
	                     BorderLayout  borderLayout1   = new BorderLayout();
	// Edge detect controls. 
											 JToolBar      edgeToolbar     = new JToolBar();
		                   JButton       edgeFillButton  = new JButton();
											 JButton       edgeAdvancedBtn = new JButton();
											 ButtonGroup   edgeColorGroup  = new ButtonGroup();
											 JRadioButton  edgeColorRedRB  = new JRadioButton();
											 JRadioButton  edgeColorGreenRB = new JRadioButton();
											 JRadioButton  edgeColorBlueRB = new JRadioButton();
											 JRadioButton  edgeColorGrayRB = new JRadioButton();
											 JRadioButton  edgeColorNoneRB = new JRadioButton();
											 JLabel        edgeLabel       = new JLabel("Edge controls");
											 JSlider       edgeThresholdSldr = new JSlider(JSlider.HORIZONTAL, 0, 500, edgeThreshold);
											 JSlider       edgeWeightRSldr     = new JSlider(JSlider.HORIZONTAL, 0, 200, (int)(edgeWeight[0]*100.0));
											 JSlider       edgeWeightGSldr     = new JSlider(JSlider.HORIZONTAL, 0, 200, (int)(edgeWeight[1]*100.0));
 											 JSlider       edgeWeightBSldr     = new JSlider(JSlider.HORIZONTAL, 0, 200, (int)(edgeWeight[2]*100.0));

											 


	/**  Construct the frame */
	public ic()
	{

		jPanel1.setDoubleBuffered(false);
		enableEvents(AWTEvent.WINDOW_EVENT_MASK);
		try
		{
			jbInit();
		} catch (Exception e)
		{
			e.printStackTrace();
		}
	}


	/**
	 *  The main program for the ic class
	 *
	 * @param  args  The command line arguments
	 */
	public static void main(String[] args)
	{

		ic         frame       = new ic();
		//Validate frames that have preset sizes
		//Pack frames that have useful preferred size info, e.g. from their layout
		if (packFrame)
		{
			frame.pack();
		}
		else
		{
			frame.validate();
		}
		//Center the window
		Dimension  screenSize  = Toolkit.getDefaultToolkit().getScreenSize();
		Dimension  frameSize   = frame.getSize();
		if (frameSize.height > screenSize.height)
		{
			frameSize.height = screenSize.height;
		}
		if (frameSize.width > screenSize.width)
		{
			frameSize.width = screenSize.width;
		}
		frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
		frame.setVisible(true);
	}


	/**
	 *  Component initialization
	 *
	 * @exception  Exception  Description of the Exception
	 */
	private void jbInit() throws Exception
	{

		contentPane = (JPanel) this.getContentPane();
		contentPane.setLayout(borderLayout1);
		this.setSize(new Dimension(850, 548));
		this.setTitle("Frame Title");

		contentPane.setMinimumSize(new Dimension(800, 600));
		contentPane.setPreferredSize(new Dimension(800, 600));

		jPanel1.setPreferredSize(new Dimension(880, 720));

		jPanel1.setToolTipText("");
		jPanel1.addMouseListener(
			new java.awt.event.MouseAdapter()
			{
				public void mouseClicked(MouseEvent e)
				{
					jPanel1_mouseClicked(e);
				}
			});
		jPanel1.addMouseMotionListener(
			new java.awt.event.MouseMotionAdapter()
			{
				public void mouseDragged(MouseEvent e)
				{
					jPanel1_mouseDragged(e);
				}
			});

		jPanel2.setBorder(BorderFactory.createEtchedBorder());
		southPanel.setLayout(new BoxLayout(southPanel, BoxLayout.Y_AXIS));
		southPanel.add(jPanel2);
		jRadioButtonOrange.setText("orange");
		jRadioButtonOrange.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					jRadioButtonOrange_actionPerformed(e);
				}
			});
		jRadioButtonBlue.setText("blue");
		jRadioButtonBlue.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					jRadioButtonBlue_actionPerformed(e);
				}
			});
		jRadioButtonGreen.setText("green");
		jRadioButtonGreen.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					jRadioButtonGreen_actionPerformed(e);
				}
			});
		jRadioButtonYellow.setText("yellow");
		jRadioButtonYellow.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					jRadioButtonYellow_actionPerformed(e);
				}
			});
		jRadioButtonPink.setText("pink");
		jRadioButtonPink.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					jRadioButtonPink_actionPerformed(e);
				}
			});
		jRadioButtonBlueDog.setText("blue dog");
		jRadioButtonBlueDog.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					jRadioButtonBlueDog_actionPerformed(e);
				}
			});
        jRadioButtonRedDog.setText("red dog");           
		jRadioButtonRedDog.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					jRadioButtonRedDog_actionPerformed(e);
				}
			});
		jRadioButtonGreenField.setText("green field");
		jRadioButtonGreenField.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					jRadioButtonGreenField_actionPerformed(e);
				}
			});
		jRadioButtonFieldWhite.setText("field white");
		jRadioButtonFieldWhite.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					jRadioButtonFieldWhite_actionPerformed(e);
				}
			});
		jRadioButtonRobotGrey.setText("robot grey");
		jRadioButtonRobotGrey.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					jRadioButtonRobotGrey_actionPerformed(e);
				}
			});
		jRadioButtonBlack.setText("black");
		jRadioButtonBlack.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					jRadioButtonBlack_actionPerformed(e);
				}
			});
		jRadioButtonNone.setText("none");
		jRadioButtonNone.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					jRadioButtonNone_actionPerformed(e);
				}
			});


		jToolBar1.setOrientation(JToolBar.VERTICAL);
		jTextArea1.setAlignmentY((float) 0.0);
		jTextArea1.setAlignmentX((float) 0.0);
		jTextArea1.setText("No file loaded. Press \"open\" to load a file.");
		jTextArea1.setMaximumSize(new Dimension(800, 20));
		jTextArea1.setMinimumSize(new Dimension(800, 20));
		jTextArea1.setLineWrap(true);

		wandButton.setMaximumSize(new Dimension(80, 30));
		wandButton.setMinimumSize(new Dimension(80, 30));
		wandButton.setEnabled(false);

		zoombutton.setMaximumSize(new Dimension(80, 30));
		zoombutton.setMinimumSize(new Dimension(80, 30));
		zoombutton.setEnabled(false);

		undoButton.setMaximumSize(new Dimension(80, 30));
		undoButton.setMinimumSize(new Dimension(80, 30));
		undoButton.setEnabled(false);

		wandButton.setText("wand");
		wandButton.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					wandButton_actionPerformed(e);
				}
			});

		zoombutton.setText("zoom");
		zoombutton.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					zoombutton_actionPerformed(e);
				}
			});

		undoButton.setText("Undo");
		undoButton.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					undoButton_actionPerformed(e);
				}
			});

		fillButton.setMaximumSize(new Dimension(80, 30));
		fillButton.setMinimumSize(new Dimension(80, 30));
		fillButton.setText("fill");
		fillButton.setEnabled(false);
		fillButton.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					fillButton_actionPerformed(e);
				}
			});

		jTextField1.setAlignmentX((float) 0.0);
		jTextField1.setAlignmentY((float) 0.0);
		jTextField1.setMaximumSize(new Dimension(80, 30));
		jTextField1.setMinimumSize(new Dimension(80, 30));
		jTextField1.setPreferredSize(new Dimension(80, 30));
		jTextField1.setText("25");
		jTextField1.setHorizontalAlignment(SwingConstants.RIGHT);

		brushField.setAlignmentX((float) 0.0);
		brushField.setAlignmentY((float) 0.0);
		brushField.setMaximumSize(new Dimension(80, 30));
		brushField.setMinimumSize(new Dimension(80, 30));
		brushField.setPreferredSize(new Dimension(80, 30));
		brushField.setText("0");
		brushField.setHorizontalAlignment(SwingConstants.RIGHT);

		clearButton.setMaximumSize(new Dimension(80, 30));
		clearButton.setMinimumSize(new Dimension(80, 30));
		clearButton.setText("clear");
		clearButton.setEnabled(false);
		clearButton.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					clearButton_actionPerformed(e);
				}
			});
		lineButton.setMaximumSize(new Dimension(80, 30));
		lineButton.setMinimumSize(new Dimension(80, 30));
		lineButton.setText("line");
		lineButton.setEnabled(false);
		lineButton.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					lineButton_actionPerformed(e);
				}
			});
		saveButton.setMaximumSize(new Dimension(80, 30));
		saveButton.setMinimumSize(new Dimension(80, 30));
		saveButton.setText("save");
		saveButton.setEnabled(false);
		saveButton.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					saveButton_actionPerformed(e);
				}
			});
		nextButton.setMaximumSize(new Dimension(80, 30));
		nextButton.setMinimumSize(new Dimension(80, 30));
		nextButton.setText("save/next");
		nextButton.setEnabled(false);
		nextButton.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					nextButton_actionPerformed(e);
				}
			});
		paintButton.setMaximumSize(new Dimension(80, 30));
		paintButton.setMinimumSize(new Dimension(80, 30));
		paintButton.setText("brush");
		paintButton.setEnabled(false);
		paintButton.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					paintButton_actionPerformed(e);
				}
			});
		jButton1.setMaximumSize(new Dimension(80, 30));
		jButton1.setMinimumSize(new Dimension(80, 30));
		jButton1.setHorizontalTextPosition(SwingConstants.CENTER);
		jButton1.setText("open");
		jButton1.addMouseListener(
			new java.awt.event.MouseAdapter()
			{
				public void mouseClicked(MouseEvent e)
				{
					jButton1_mouseClicked(e);
				}
			});

		group.add(jRadioButtonOrange);
		group.add(jRadioButtonBlue);
		group.add(jRadioButtonGreen);
		group.add(jRadioButtonYellow);
		group.add(jRadioButtonPink);
		group.add(jRadioButtonBlueDog);
		group.add(jRadioButtonRedDog);
		group.add(jRadioButtonGreenField);
		group.add(jRadioButtonRobotGrey);
		group.add(jRadioButtonFieldWhite);
		group.add(jRadioButtonBlack);
        group.add(jRadioButtonNone);
		jRadioButtonOrange.setEnabled(false);
		jRadioButtonBlue.setEnabled(false);
		jRadioButtonGreen.setEnabled(false);
		jRadioButtonYellow.setEnabled(false);
		jRadioButtonPink.setEnabled(false);
		jRadioButtonBlueDog.setEnabled(false);
		jRadioButtonRedDog.setEnabled(false);
		jRadioButtonGreenField.setEnabled(false);
		jRadioButtonFieldWhite.setEnabled(false);
		jRadioButtonRobotGrey.setEnabled(false);
		jRadioButtonBlack.setEnabled(false);
		jRadioButtonNone.setEnabled(false);

		switch (jPanel1.color)
		{
						case BFLPanel.ORANGE:
							group.setSelected(jRadioButtonOrange.getModel(), true);
							break;
						case BFLPanel.BLUE:
							group.setSelected(jRadioButtonBlue.getModel(), true);
							break;
						case BFLPanel.GREEN:
							group.setSelected(jRadioButtonGreen.getModel(), true);
							break;
						case BFLPanel.YELLOW:
							group.setSelected(jRadioButtonYellow.getModel(), true);
							break;
						case BFLPanel.PINK:
							group.setSelected(jRadioButtonPink.getModel(), true);
							break;
						case BFLPanel.BLUEDOG:
							group.setSelected(jRadioButtonBlueDog.getModel(), true);
							break;
						case BFLPanel.REDDOG:
							group.setSelected(jRadioButtonRedDog.getModel(), true);
							break;
						case BFLPanel.GREENFIELD:
							group.setSelected(jRadioButtonGreenField.getModel(), true);
							break;
						case BFLPanel.FIELDWHITE:
							group.setSelected(jRadioButtonFieldWhite.getModel(), true);
							break;
                        case BFLPanel.ROBOTGREY:
                            group.setSelected(jRadioButtonRobotGrey.getModel(), true);
                            break;
                        case BFLPanel.BLACK:
                            group.setSelected(jRadioButtonBlack.getModel(), true);
                            break;
						case BFLPanel.NONE:
							group.setSelected(jRadioButtonNone.getModel(), true);
							break;
		}

		contentPane.add(southPanel, BorderLayout.SOUTH);
		jPanel2.add(new JLabel("Mark as:"), null);
		jPanel2.add(jRadioButtonOrange, null);
		jPanel2.add(jRadioButtonBlue, null);
		jPanel2.add(jRadioButtonGreen, null);
		jPanel2.add(jRadioButtonYellow, null);
		jPanel2.add(jRadioButtonPink, null);
		jPanel2.add(jRadioButtonBlueDog, null);
		jPanel2.add(jRadioButtonRedDog, null);
		jPanel2.add(jRadioButtonGreenField, null);
		jPanel2.add(jRadioButtonRobotGrey, null);
		jPanel2.add(jRadioButtonFieldWhite, null);
		jPanel2.add(jRadioButtonBlack, null);
        jPanel2.add(jRadioButtonNone, null);
		contentPane.add(jToolBar1, BorderLayout.EAST);
		jToolBar1.add(jToolLabel, null);
		southPanel.add(jTextArea1, null);
		jToolBar1.add(jButton1, null);
		jToolBar1.add(saveButton, null);
		jToolBar1.add(nextButton, null);
		jToolBar1.add(new JToolBar.Separator(), null);
		jToolBar1.add(paintButton, null);
		jToolBar1.add(brushField, null);
		jToolBar1.add(new JToolBar.Separator(), null);
		jToolBar1.add(lineButton, null);
		jToolBar1.add(new JToolBar.Separator(), null);
		jToolBar1.add(fillButton, null);
		jToolBar1.add(new JToolBar.Separator(), null);
		jToolBar1.add(wandButton, null);
		jToolBar1.add(jTextField1, null);
		jToolBar1.add(new JToolBar.Separator(), null);
		jToolBar1.add(clearButton, null);
		jToolBar1.add(new JToolBar.Separator(), null);
		jToolBar1.add(zoombutton, null);
		jToolBar1.add(new JToolBar.Separator(), null);
		jToolBar1.add(undoButton, null);
		undoButton.setEnabled(false);

		contentPane.add(northPanel, BorderLayout.NORTH);
		contentPane.add(edgeToolbar, BorderLayout.WEST);
		edgeToolbar.setOrientation(JToolBar.VERTICAL);
		edgeFillButton.setText("Fill (edge)");
		edgeFillButton.setMaximumSize(new Dimension(150, 30));
		edgeFillButton.setMinimumSize(new Dimension(150, 30));
		edgeFillButton.setEnabled(false);
		edgeFillButton.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					edgeFillButton_actionPerformed(e);
				}
			});
		edgeAdvancedBtn.setText("Advanced ...");
		edgeAdvancedBtn.setEnabled(false);
		edgeAdvancedBtn.setMaximumSize(new Dimension(150,30));
		edgeAdvancedBtn.setMinimumSize(new Dimension(150,30));
		edgeAdvancedBtn.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					edgeAdvancedBtn_actionPerformed(e);
				}
			});
		edgeThresholdSldr.addChangeListener(
			new javax.swing.event.ChangeListener()
			{
				public void stateChanged(ChangeEvent e)
				{
					edgeThreshold_stateChanged(e);
				}
			});
		edgeThresholdSldr.setMajorTickSpacing(100);
		edgeThresholdSldr.setMinorTickSpacing(20);
		edgeThresholdSldr.setPaintTicks(true);
		edgeThresholdSldr.setPaintLabels(true);
		edgeThresholdSldr.setEnabled(false);

		edgeWeightRSldr.addChangeListener(
			new javax.swing.event.ChangeListener()
			{
				public void stateChanged(ChangeEvent e)
				{
					edgeWeightR_stateChanged(e);
				}
			});
		edgeWeightRSldr.setMajorTickSpacing(50);
		edgeWeightRSldr.setMinorTickSpacing(5);
		edgeWeightRSldr.setPaintTicks(true);
		edgeWeightRSldr.setPaintLabels(true);
		edgeWeightRSldr.setForeground(Color.RED);
		edgeWeightRSldr.setEnabled(false);

		edgeWeightGSldr.addChangeListener(
			new javax.swing.event.ChangeListener()
			{
				public void stateChanged(ChangeEvent e)
				{
					edgeWeightG_stateChanged(e);
				}
			});
		edgeWeightGSldr.setMajorTickSpacing(50);
		edgeWeightGSldr.setMinorTickSpacing(5);
		edgeWeightGSldr.setPaintTicks(true);
		edgeWeightGSldr.setPaintLabels(true);
		edgeWeightGSldr.setForeground(Color.GREEN);
		edgeWeightGSldr.setEnabled(false);

		edgeWeightBSldr.addChangeListener(
			new javax.swing.event.ChangeListener()
			{
				public void stateChanged(ChangeEvent e)
				{
					edgeWeightB_stateChanged(e);
				}
			});
		edgeWeightBSldr.setMajorTickSpacing(50);
		edgeWeightBSldr.setMinorTickSpacing(5);
		edgeWeightBSldr.setPaintTicks(true);
		edgeWeightBSldr.setPaintLabels(true);
		edgeWeightBSldr.setForeground(Color.BLUE);
		edgeWeightBSldr.setEnabled(false);


		
		edgeColorRedRB.setText("Red");
		edgeColorRedRB.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					edgeColorRedRB_actionPerformed(e);
				}
			});
		edgeColorGreenRB.setText("Green");
		edgeColorGreenRB.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					edgeColorGreenRB_actionPerformed(e);
				}
			});

		edgeColorBlueRB.setText("Blue");
		edgeColorBlueRB.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					edgeColorBlueRB_actionPerformed(e);
				}
			});

		edgeColorGrayRB.setText("Gray");
		edgeColorGrayRB.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					edgeColorGrayRB_actionPerformed(e);
				}
			});

		edgeColorNoneRB.setText("Hidden");
		edgeColorNoneRB.addActionListener(
			new java.awt.event.ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					edgeColorNoneRB_actionPerformed(e);
				}
			});
		edgeColorGroup.add(edgeColorRedRB);
		edgeColorGroup.add(edgeColorGreenRB);
		edgeColorGroup.add(edgeColorBlueRB);
		edgeColorGroup.add(edgeColorGrayRB);
		edgeColorGroup.add(edgeColorNoneRB);
		edgeColorRedRB.setEnabled(false);
		edgeColorGreenRB.setEnabled(false);
		edgeColorBlueRB.setEnabled(false);
		edgeColorGrayRB.setEnabled(false);
		edgeColorNoneRB.setEnabled(false);

		group.setSelected(edgeColorRedRB.getModel(), true);
		edgeToolbar.add(edgeLabel, null);
		edgeToolbar.add(edgeFillButton, null);
		edgeToolbar.add(edgeAdvancedBtn, null);
		edgeToolbar.add(new JToolBar.Separator(), null);
		edgeToolbar.add(new JLabel("Edge mark color:"), null);
		edgeToolbar.add(edgeColorRedRB, null);
		edgeToolbar.add(edgeColorGreenRB, null);
		edgeToolbar.add(edgeColorBlueRB, null);
		edgeToolbar.add(edgeColorGrayRB, null);
		edgeToolbar.add(edgeColorNoneRB, null);
		edgeToolbar.add(new JToolBar.Separator(), null);
		edgeToolbar.add(new JLabel("Edge threshold:"), null);
		edgeToolbar.add(edgeThresholdSldr, null);
		edgeToolbar.add(edgeWeightRSldr, null);
		edgeToolbar.add(edgeWeightGSldr, null);
		edgeToolbar.add(edgeWeightBSldr, null);


		contentPane.add(jPanel1, BorderLayout.CENTER);

		jPanel1.setSize(616, 420);

		//set the default directory
		jFileChooser1.setCurrentDirectory(new File("c:\\Calibration Pics\\"));

	}


	/**
	 *  Overridden so we can exit when window is closed
	 *
	 * @param  e  Description of the Parameter
	 */
	protected void processWindowEvent(WindowEvent e)
	{
		super.processWindowEvent(e);
		if (e.getID() == WindowEvent.WINDOW_CLOSING)
		{
			System.exit(0);
		}
	}


	//this button displays the file choose dialog
	/**
	 *  Description of the Method
	 *
	 * @param  e  Description of the Parameter
	 */
	void jButton1_mouseClicked(MouseEvent e)
	{

		int     returnVal  = jFileChooser1.showOpenDialog(this);
		if (returnVal == JFileChooser.CANCEL_OPTION)
		{
			return;
		}
		currentFile = jFileChooser1.getSelectedFile();
		String  filename   = currentFile.getPath();
		readFile(filename);
		undoButton.setEnabled(false);
		this.setTitle(filename);
		group.setSelected(jRadioButtonNone.getModel(), true);
		jPanel1.color = BFLPanel.NONE;
		displayColor();
		
		wandButton.setEnabled(true);
		zoombutton.setEnabled(true);
		undoButton.setEnabled(true);
		fillButton.setEnabled(true);
		clearButton.setEnabled(true);
		lineButton.setEnabled(true);
		saveButton.setEnabled(true);
		nextButton.setEnabled(true);
		paintButton.setEnabled(true);
		undoButton.setEnabled(true);
		edgeFillButton.setEnabled(true);
		edgeAdvancedBtn.setEnabled(true);
		edgeThresholdSldr.setEnabled(true);
		edgeWeightRSldr.setEnabled(true);
		edgeWeightGSldr.setEnabled(true);
		edgeWeightBSldr.setEnabled(true);
		jRadioButtonOrange.setEnabled(true);
		jRadioButtonBlue.setEnabled(true);
		jRadioButtonGreen.setEnabled(true);
		jRadioButtonYellow.setEnabled(true);
		jRadioButtonPink.setEnabled(true);
		jRadioButtonBlueDog.setEnabled(true);
		jRadioButtonRedDog.setEnabled(true);
		jRadioButtonGreenField.setEnabled(true);
		jRadioButtonFieldWhite.setEnabled(true);
		jRadioButtonRobotGrey.setEnabled(true);
		jRadioButtonBlack.setEnabled(true);
        jRadioButtonNone.setEnabled(true);
		edgeColorRedRB.setEnabled(true);
		edgeColorGreenRB.setEnabled(true);
		edgeColorBlueRB.setEnabled(true);
		edgeColorGrayRB.setEnabled(true);
		edgeColorNoneRB.setEnabled(true);
		

		
		

		
		
	}


	//saves the file when this button is clicked
	/**
	 *  Description of the Method
	 *
	 * @param  e  Description of the Parameter
	 */
	void saveButton_actionPerformed(ActionEvent e)
	{

		try
		{

			String            filename  = jFileChooser1.getSelectedFile().getPath();
			FileOutputStream  BFL       = new FileOutputStream(filename);

			byte[]            lineY     = new byte[PIC_WIDTH];
			byte[]            lineU     = new byte[PIC_WIDTH];
			byte[]            lineV     = new byte[PIC_WIDTH];
			byte[]            lineC     = new byte[PIC_WIDTH];

			for (int i = 0; i < PIC_HEIGHT; i++)
			{

				for (int j = 0; j < PIC_WIDTH; j++)
				{

					lineY[j] = jPanel1.Y[j][i];
					lineU[j] = jPanel1.U[j][i];
					lineV[j] = jPanel1.V[j][i];
					lineC[j] = jPanel1.C[j][i];
				}

				BFL.write(lineY);
				BFL.write(lineU);
				BFL.write(lineV);
				BFL.write(lineC);

			}

			jTextArea1.setText("saved");
		} catch (FileNotFoundException ex)
		{
			jTextArea1.setText("file not found");
		} catch (IOException ex)
		{
			jTextArea1.setText("an IOException occured");
		}
	}


	void nextButton_actionPerformed(ActionEvent e)
	{
		if (currentFile != null)
		{
			saveButton_actionPerformed(e);
			//ONLY WORKS IF THE FILES ARE NAMED ____NN.bfl
			//and just increments NN.
			String fileName = currentFile.getPath();
System.out.println(jTextArea1.getText());
			if (fileName.endsWith(".bfl"))
			{
				int fileNum;
				try
				{
					fileNum = Integer.valueOf(fileName.substring(fileName.length() - 6, fileName.length() - 4)).intValue();
				}
				catch (NumberFormatException e1)
				{
					jTextArea1.setText("Current file is not of form \"____nn.bfl\"");
					return;
				}
				fileNum ++;
				if (fileNum < 10)
				{
					fileName = fileName.substring(0, fileName.length() - 5) + Integer.toString(fileNum) + ".bfl";
				}
				else
				{
					fileName = fileName.substring(0, fileName.length() - 6) + Integer.toString(fileNum) + ".bfl";
				}
				readFile(fileName);
				currentFile = new File(fileName);
				undoButton.setEnabled(false);
				this.setTitle(fileName);
				group.setSelected(jRadioButtonNone.getModel(), true);
				jPanel1.color = BFLPanel.NONE;
				displayColor();
			}
			else
			{
				jTextArea1.setText("Current file is not .bfl");
			}
		}
		else
		{
			jTextArea1.setText("No previous file!");
		}
	}

	//clears all layers of any classifcation information
	/**
	 *  Description of the Method
	 *
	 * @param  e  Description of the Parameter
	 */
	void clearButton_actionPerformed(ActionEvent e)
	{
		for (int j = 0; j < PIC_WIDTH; j++)
		{
			for (int i = 0; i < PIC_HEIGHT; i++)
			{

				jPanel1.C[j][i] = BFLPanel.NONE;
			}
		}

		//redisplay new information
		displayColor();
	}


	//reads the BFL file and stores the YUVC information in four arrays.
	// UPDATE: Also performs edge detection and stores the result in 
	//         a PIC_WIDTH by PIC_HEIGHT array (non-thresholded). 
	/**
	 *  Description of the Method
	 *
	 * @param  filename  Description of the Parameter
	 */
	void readFile(String filename)
	{
		jTextArea1.setText("About to read " + filename);
		try
		{

			FileInputStream  BFL    = new FileInputStream(filename);

			byte[]           lineY  = new byte[PIC_WIDTH];
			byte[]           lineU  = new byte[PIC_WIDTH];
			byte[]           lineV  = new byte[PIC_WIDTH];
			byte[]           lineC  = new byte[PIC_WIDTH];

			for (int i = 0; i < PIC_HEIGHT; i++)
			{

				BFL.read(lineY);
				BFL.read(lineU);
				BFL.read(lineV);
				BFL.read(lineC);

				for (int j = 0; j < PIC_WIDTH; j++)
				{
					jPanel1.Y[j][i] = (lineY[j]);
					jPanel1.U[j][i] = (lineU[j]);
					jPanel1.V[j][i] = (lineV[j]);
					jPanel1.C[j][i] = (lineC[j]);

					int  y    = lineY[j] & 0xff;
					int  u    = lineU[j] & 0xff;
					int  v    = lineV[j] & 0xff;

					//change range of u and v for rgb conversion
					u -= 128;
					v -= 128;

					int  r    = (int) ((1.164 * y) + (1.596 * u));
					int  g    = (int) ((1.164 * y) - (0.813 * u) - (0.391 * v));
					int  b    = (int) ((1.164 * y) + (1.596 * v));

					if (r < 0)
					{
						r = 0;
					}
					else if (r > 255)
					{
						r = 255;
					}
					if (g < 0)
					{
						g = 0;
					}
					else if (g > 255)
					{
						g = 255;
					}
					if (b < 0)
					{
						b = 0;
					}
					else if (b > 255)
					{
						b = 255;
					}

					int  rgb  = ((r << 16) | (g << 8) | b);
					jPanel1.rgbPlane[j][i] = rgb;
				}
			}

			//UPDATE: Now perform Sobel edge detection and store the tallies (*NOT* the thresholds)
			//        in edgeArray.
			edgeDetectSobel();
			for (int h = 0; h < PIC_HEIGHT; h ++)
			{
				for (int w = 0; w < PIC_WIDTH; w ++)
				{
					if (edgeArray[h][w] > edgeThreshold)
					{
						jPanel1.rgbOverlay[w][h] = edgeColor;
					}
				}
			}
		} catch (FileNotFoundException ex)
		{
			jTextArea1.setText("file " + filename + " not found");
		} catch (IOException ex)
		{
			jTextArea1.setText("an IOException occured reading " + filename);
		}
		jTextArea1.setText("File " + filename + " loaded.");
	}


	private void edgeDetectSobel()
	{
		//WARNING: Arrays here are indexed HEIGHT then WIDTH! Not like everywhere else!
		int inPic[][][] = new int[PIC_HEIGHT][PIC_WIDTH][3];
		//We need to convert from rgb into components.
		for (int h = 0; h < PIC_HEIGHT; h ++)
		{
			for (int w = 0; w < PIC_WIDTH; w ++)
			{
				inPic[h][w][0] = (jPanel1.rgbPlane[w][h] >>> 16) & 0x0FF;
				inPic[h][w][1] = (jPanel1.rgbPlane[w][h] >>> 8) & 0x0FF;
				inPic[h][w][2] = jPanel1.rgbPlane[w][h] & 0x0FF;
				//Reinitialize overlay
				jPanel1.rgbOverlay[w][h] = -1;
			}
		}
		for (int h = 0; h < PIC_HEIGHT; h ++)
		{
			for (int w = 0; w < PIC_WIDTH; w ++)
			{
				if ((h == 0) || (w == 0) || (h == PIC_HEIGHT - 1) || (w == PIC_WIDTH - 1))
				{//Remove the edges (or we'll get array out of bounds).
					edgeArray[h][w] = Integer.MAX_VALUE;
				}
				else
				{
					int red, green, blue;
					
					red = Math.abs(	inPic[h-1][w-1][0] + 2*inPic[h-1][w][0] + inPic[h-1][w+1][0]
											-	inPic[h+1][w-1][0] - 2*inPic[h+1][w][0] - inPic[h+1][w+1][0] )
						+ Math.abs(	inPic[h-1][w+1][0] + 2*inPic[h][w+1][0] + inPic[h+1][w+1][0]
											- inPic[h-1][w-1][0] - 2*inPic[h][w-1][0] - inPic[h+1][w-1][0] );
					green = Math.abs(	inPic[h-1][w-1][1] + 2*inPic[h-1][w][1] + inPic[h-1][w+1][1]
											-	inPic[h+1][w-1][1] - 2*inPic[h+1][w][1] - inPic[h+1][w+1][1] )
						+ Math.abs(	inPic[h-1][w+1][1] + 2*inPic[h][w+1][1] + inPic[h+1][w+1][1]
											- inPic[h-1][w-1][1] - 2*inPic[h][w-1][1] - inPic[h+1][w-1][1] );
					blue = Math.abs(	inPic[h-1][w-1][2] + 2*inPic[h-1][w][2] + inPic[h-1][w+1][2]
											-	inPic[h+1][w-1][2] - 2*inPic[h+1][w][2] - inPic[h+1][w+1][2] )
						+ Math.abs(	inPic[h-1][w+1][2] + 2*inPic[h][w+1][2] + inPic[h+1][w+1][2]
											- inPic[h-1][w-1][2] - 2*inPic[h][w-1][2] - inPic[h+1][w-1][2] );

					edgeArray[h][w] = (int)((double)red * edgeWeight[0] + (double)green * edgeWeight[1] + (double)blue * edgeWeight[2]);
				}
			}
		}
	}

	/**  Description of the Method */
	public void displayColor()
	{

		jPanel1.paintComponent(jPanel1.getGraphics());
	}


	/**
	 *  Description of the Method
	 *
	 * @param  e  Description of the Parameter
	 */
	void jRadioButtonOrange_actionPerformed(ActionEvent e)
	{
		jPanel1.color = BFLPanel.ORANGE;
		displayColor();
	}


	/**
	 *  Description of the Method
	 *
	 * @param  e  Description of the Parameter
	 */
	void jRadioButtonBlue_actionPerformed(ActionEvent e)
	{
		jPanel1.color = BFLPanel.BLUE;
		displayColor();
	}


	/**
	 *  Description of the Method
	 *
	 * @param  e  Description of the Parameter
	 */
	void jRadioButtonGreen_actionPerformed(ActionEvent e)
	{
		jPanel1.color = BFLPanel.GREEN;
		displayColor();
	}


	/**
	 *  Description of the Method
	 *
	 * @param  e  Description of the Parameter
	 */
	void jRadioButtonYellow_actionPerformed(ActionEvent e)
	{
		jPanel1.color = BFLPanel.YELLOW;
		displayColor();
	}


	/**
	 *  Description of the Method
	 *
	 * @param  e  Description of the Parameter
	 */
	void jRadioButtonPink_actionPerformed(ActionEvent e)
	{
		jPanel1.color = BFLPanel.PINK;
		displayColor();
	}


	/**
	 *  Description of the Method
	 *
	 * @param  e  Description of the Parameter
	 */
	void jRadioButtonBlueDog_actionPerformed(ActionEvent e)
	{
		jPanel1.color = BFLPanel.BLUEDOG;
		displayColor();
	}


	/**
	 *  Description of the Method
	 *
	 * @param  e  Description of the Parameter
	 */
	void jRadioButtonRedDog_actionPerformed(ActionEvent e)
	{
		jPanel1.color = BFLPanel.REDDOG;
		displayColor();
	}


	/**
	 *  Description of the Method
	 *
	 * @param  e  Description of the Parameter
	 */
	void jRadioButtonGreenField_actionPerformed(ActionEvent e)
	{
		jPanel1.color = BFLPanel.GREENFIELD;
		displayColor();
	}


	void jRadioButtonFieldWhite_actionPerformed(ActionEvent e)
	{
		jPanel1.color = BFLPanel.FIELDWHITE;
		displayColor();
	}

	/**
	 *  Description of the Method
	 *
	 * @param  e  Description of the Parameter
	 */
	void jRadioButtonRobotGrey_actionPerformed(ActionEvent e)
	{
		jPanel1.color = BFLPanel.ROBOTGREY;
		displayColor();
	}

	/**
	 *  Description of the Method
	 *
	 * @param  e  Description of the Parameter
	 */
	void jRadioButtonBlack_actionPerformed(ActionEvent e)
	{
		jPanel1.color = BFLPanel.BLACK;
		displayColor();
	}

	//when no color is selected for highlighting
	/**
	 *  Description of the Method
	 *
	 * @param  e  Description of the Parameter
	 */
	void jRadioButtonNone_actionPerformed(ActionEvent e)
	{
		jPanel1.color = BFLPanel.NONE;
		displayColor();
	}


	/**
	 *  Description of the Method
	 *
	 * @param  e  Description of the Parameter
	 */
	void paintButton_actionPerformed(ActionEvent e)
	{
		saveUndo();
		selectedTool = "brush";
		jTextArea1.setText("brush");
	}


	/**
	 *  Description of the Method
	 *
	 * @param  e  Description of the Parameter
	 */
	void wandButton_actionPerformed(ActionEvent e)
	{
		selectedTool = "wand";
		jTextArea1.setText("wand");
	}


	/**
	 *  Description of the Method
	 *
	 * @param  e  Description of the Parameter
	 */
	void lineButton_actionPerformed(ActionEvent e)
	{
		selectedTool = "line";
		jTextArea1.setText("line");
	}


	/**
	 *  Description of the Method
	 *
	 * @param  e  Description of the Parameter
	 */
	void fillButton_actionPerformed(ActionEvent e)
	{
		selectedTool = "fill";
		jTextArea1.setText("fill");
	}


	/**
	 *  Description of the Method
	 *
	 * @param  e  Description of the Parameter
	 */
	void zoombutton_actionPerformed(ActionEvent e)
	{
		selectedTool = "zoom";
		jTextArea1.setText("zoom");
	}


	void undoButton_actionPerformed(ActionEvent e)
	{
		undoButton.setEnabled(false);
		undo();
	}


	/**
	 *  Description of the Method
	 *
	 * @param  e  Description of the Parameter
	 */
	void jPanel1_mouseDragged(MouseEvent e)
	{
		//convert a screen coordinate to picture relative
		int  x  = jPanel1.convertX(e.getX());
		int  y  = jPanel1.convertY(e.getY());

		if (SwingUtilities.isRightMouseButton(e))
		{
			highlight(x, y, false);
		}
		else
		{
			highlight(x, y, true);
		}
	}


	/**
	 *  Description of the Method
	 *
	 * @param  e  Description of the Parameter
	 */
	void jPanel1_mouseClicked(MouseEvent e)
	{
		//convert a screen coordinate to picture relative
		int  x  = jPanel1.convertX(e.getX());
		int  y  = jPanel1.convertY(e.getY());

		if (SwingUtilities.isRightMouseButton(e))
		{
			highlight(x, y, false);
		}
		else
		{
			highlight(x, y, true);
		}
	}





	void edgeFillButton_actionPerformed(ActionEvent e)
	{
		selectedTool = "edgefill";
		jTextArea1.setText("Edge fill");
	}

	void edgeAdvancedBtn_actionPerformed(ActionEvent e)
	{}

	void edgeColorRedRB_actionPerformed(ActionEvent e)
	{
		edgeColor = Color.RED.getRGB();
		for (int h = 0; h < PIC_HEIGHT; h ++)
		{
			for (int w = 0; w < PIC_WIDTH; w ++)
			{
				if (edgeArray[h][w] > edgeThreshold)
				{
					jPanel1.rgbOverlay[w][h] = edgeColor;
				}
			}
		}
		jPanel1.repaint();
	}

	void edgeColorGreenRB_actionPerformed(ActionEvent e)
	{
		edgeColor = Color.GREEN.getRGB();
		for (int h = 0; h < PIC_HEIGHT; h ++)
		{
			for (int w = 0; w < PIC_WIDTH; w ++)
			{
				if (edgeArray[h][w] > edgeThreshold)
				{
					jPanel1.rgbOverlay[w][h] = edgeColor;
				}
			}
		}
		jPanel1.repaint();
	}

	void edgeColorBlueRB_actionPerformed(ActionEvent e)
	{
		edgeColor = Color.BLUE.getRGB();
		for (int h = 0; h < PIC_HEIGHT; h ++)
		{
			for (int w = 0; w < PIC_WIDTH; w ++)
			{
				if (edgeArray[h][w] > edgeThreshold)
				{
					jPanel1.rgbOverlay[w][h] = edgeColor;
				}
			}
		}
		jPanel1.repaint();
	}

	void edgeColorGrayRB_actionPerformed(ActionEvent e)
	{
		for (int h = 0; h < PIC_HEIGHT; h ++)
		{
			for (int w = 0; w < PIC_WIDTH; w ++)
			{
				if (edgeArray[h][w] > edgeThreshold)
				{
					jPanel1.rgbOverlay[w][h] = Color.GRAY.getRGB();
				}
			}
		}
		jPanel1.repaint();
	}



	void edgeColorNoneRB_actionPerformed(ActionEvent e)
	{
		for (int h = 0; h < PIC_HEIGHT; h ++)
		{
			for (int w = 0; w < PIC_WIDTH; w ++)
			{
				if (edgeArray[h][w] > edgeThreshold)
				{
					jPanel1.rgbOverlay[w][h] = -1;
				}
			}
		}
		jPanel1.repaint();
	}


	void edgeThreshold_stateChanged(ChangeEvent e)
	{
		edgeThreshold = edgeThresholdSldr.getValue();
		for (int h = 0; h < PIC_HEIGHT; h ++)
		{
			for (int w = 0; w < PIC_WIDTH; w ++)
			{
				if (edgeArray[h][w] > edgeThreshold)
				{
					jPanel1.rgbOverlay[w][h] = edgeColor;
				}
				else
				{
					jPanel1.rgbOverlay[w][h] = -1;
				}
			}
		}
		jPanel1.repaint();
	}

	void edgeWeightR_stateChanged(ChangeEvent e)
	{
		edgeWeight[0] = (double)(edgeWeightRSldr.getValue())/100.0;
		edgeDetectSobel();
		for (int h = 0; h < PIC_HEIGHT; h ++)
		{
			for (int w = 0; w < PIC_WIDTH; w ++)
			{
				if (edgeArray[h][w] > edgeThreshold)
				{
					jPanel1.rgbOverlay[w][h] = edgeColor;
				}
				else
				{
					jPanel1.rgbOverlay[w][h] = -1;
				}

			}
		}
		jPanel1.repaint();
	}

	void edgeWeightG_stateChanged(ChangeEvent e)
	{
		edgeWeight[1] = (double)(edgeWeightGSldr.getValue())/100.0;
		edgeDetectSobel();
		for (int h = 0; h < PIC_HEIGHT; h ++)
		{
			for (int w = 0; w < PIC_WIDTH; w ++)
			{
				if (edgeArray[h][w] > edgeThreshold)
				{
					jPanel1.rgbOverlay[w][h] = edgeColor;
				}
				else
				{
					jPanel1.rgbOverlay[w][h] = -1;
				}
			}
		}
		jPanel1.repaint();
	}

	void edgeWeightB_stateChanged(ChangeEvent e)
	{
		edgeWeight[2] = (double)(edgeWeightBSldr.getValue())/100.0;
		edgeDetectSobel();
		for (int h = 0; h < PIC_HEIGHT; h ++)
		{
			for (int w = 0; w < PIC_WIDTH; w ++)
			{
				if (edgeArray[h][w] > edgeThreshold)
				{
					jPanel1.rgbOverlay[w][h] = edgeColor;
				}
			}
		}
		jPanel1.repaint();
	}


	void saveUndo()
	{
		undoButton.setEnabled(true);
		jPanel1.saveUndo();
	}

	void undo()
	{
		jPanel1.undo();
		undoButton.setEnabled(false);
	}


	//highlights using the current tool
	/**
	 *  Description of the Method
	 *
	 * @param  x         Description of the Parameter
	 * @param  y         Description of the Parameter
	 * @param  painting  Description of the Parameter
	 */
	void highlight(int x, int y, boolean painting)
	{
		if ((jPanel1.color == BFLPanel.NONE) && currentFile != null)
		{
			jTextArea1.setText("Please select a color to classify first!");
		}
		if (selectedTool.equals("zoom"))
		{
			if (painting)
			{
				jPanel1.setQuadrant(x, y);
			}
			else
			{
				jPanel1.setQuadrant(-1, -1);
			}
		}
		//if no color is selected, we dont allow the user to highlight or erase
		if (jPanel1.color == BFLPanel.NONE)
		{
			return;
		}

		if (selectedTool.equals("brush"))
		{//We save undo for this when the button is pressed
		//or we'll only undo the last pixel.
			int  size  = Integer.parseInt(brushField.getText());
			for (int i = x - size; i <= x + size; i++)
			{
				for (int j = y - size; j <= y + size; j++)
				{
					drawPixel(i, j, painting);
				}
			}
		}
		else if (selectedTool.equals("wand"))
		{
			//possible array exception here if someone clicks outside image
			if (x >= 0 && x < PIC_WIDTH && y >= 0 && y < PIC_HEIGHT)
			{
				saveUndo();
				startRGB = jPanel1.rgbPlane[x][y];
				startR = (startRGB >> 16);
				startG = (startRGB >> 8) & 0xff;
				startB = (startRGB) & 0xff;
				threshold = Integer.parseInt(jTextField1.getText());
				wand(x, y, painting);
			}
		}
		else if (selectedTool.equals("edgefill"))
		{
			saveUndo();
			if (x >= 0 && x < PIC_WIDTH && y >= 0 && y < PIC_HEIGHT)
			{
				edgeFill(x, y, painting);
			}
		}
		else if (selectedTool.equals("line"))
		{
			saveUndo();
			line(x, y, painting);
		}
		else if (selectedTool.equals("fill"))
		{

			//possible array exception here if someone clicks outside image

			if (x >= 0 && x < PIC_WIDTH && y >= 0 && y < PIC_HEIGHT)
			{
				saveUndo();
				startRGB = jPanel1.rgbPlane[x][y];
				startR = (startRGB >> 16);
				startG = (startRGB >> 8) & 0xff;
				startB = (startRGB) & 0xff;
				threshold = 300;
				wand(x, y, painting);
			}
		}

	}


	//higlights a single pixel (x,y) and sets the Cplane value
	//if painting is true we are highligting
	//otherwise we are unhighlighting
	/**
	 *  Description of the Method
	 *
	 * @param  x         Description of the Parameter
	 * @param  y         Description of the Parameter
	 * @param  painting  Description of the Parameter
	 */
	void drawPixel(int x, int y, boolean painting)
	{

		//check bounds of x and y
		if (!(0 <= x && x < PIC_WIDTH && 0 <= y && y < PIC_HEIGHT))
		{
			return;
		}

		if (painting)
		{
			//not allowed to draw over already classified pixels
			if (jPanel1.C[x][y] != BFLPanel.NONE)
			{
				return;
			}

			jPanel1.C[x][y] = jPanel1.color;
			jPanel1.drawBox(x, y, jPanel1.getGraphics());
		}
		//erasing
		else
		{

			//not allowed to erase wrong color
			if (jPanel1.C[x][y] != jPanel1.color)
			{
				return;
			}

			jPanel1.C[x][y] = BFLPanel.NONE;
			jPanel1.drawSquare(x, y, jPanel1.getGraphics());
		}
	}


	//selects a region using magic wand starting at x,y
	//painting is used to determine whether we are selecting or deselecting
	/**
	 *  Description of the Method
	 *
	 * @param  x  Description of the Parameter
	 * @param  y  Description of the Parameter
	 */
	void wand(int x, int y, boolean painting)
	{

		// stack overflow occurs sometimes
		if (!(((jPanel1.C[x][y] == BFLPanel.NONE) && painting) ||
				((jPanel1.C[x][y] == jPanel1.color) && !painting)))
		{
			return;
		}

		int  current;
		int  r;
		int  g;
		int  b;

		current = jPanel1.rgbPlane[x][y];


		r = current >> 16 & 0xff;
		g = (current >> 8) & 0xff;
		b = (current) & 0xff;


		//if current pixel is close enough to current one
		if ((Math.abs(r - startR) < threshold) &&
				(Math.abs(g - startG) < threshold) &&
				(Math.abs(b - startB) < threshold))
		{

			drawPixel(x, y, painting);

			//recurse over the four neighbours
			//only if not selected (if we are deselecting we want to do the opposite) (^ = XOR)
			//if(x>0 && (jPanel1.C[x-1][y]==BFLPanel.NONE))
			if (x > 0)
			{
				if (((jPanel1.C[x - 1][y] == BFLPanel.NONE) && painting) ||
						((jPanel1.C[x - 1][y] == jPanel1.color) && !painting))
				{
					wand(x - 1, y, painting);
				}
			}

			//if(x<(PIC_WIDTH-1) && (jPanel1.C[x+1][y]==BFLPanel.NONE))
			if (x < (PIC_WIDTH - 1))
			{
				if (((jPanel1.C[x + 1][y] == BFLPanel.NONE) && painting) ||
						((jPanel1.C[x + 1][y] == jPanel1.color) && !painting))
				{
					wand(x + 1, y, painting);
				}
			}

			//if(y>0 && (jPanel1.C[x][y-1]==BFLPanel.NONE))
			if (y > 0)
			{
				if (((jPanel1.C[x][y - 1] == BFLPanel.NONE) && painting) ||
						((jPanel1.C[x][y - 1] == jPanel1.color) && !painting))
				{
					wand(x, y - 1, painting);
				}
			}

			//if(y<(PIC_HEIGHT-1) && (jPanel1.C[x][y+1]==BFLPanel.NONE))
			if (y < (PIC_HEIGHT - 1))
			{
				if (((jPanel1.C[x][y + 1] == BFLPanel.NONE) && painting) ||
						((jPanel1.C[x][y + 1] == jPanel1.color) && !painting))
				{
					wand(x, y + 1, painting);
				}
			}

		}
	}



	/**
	 * edgeFill: Similar to wand but keys on the defined edges according to the threshold instead.
	 */
	void edgeFill(int x, int y, boolean painting)
	{
		if (!(((jPanel1.C[x][y] == BFLPanel.NONE) && painting) ||
				((jPanel1.C[x][y] == jPanel1.color) && !painting)))
		{
			return;
		}
		if (edgeArray[y][x] < edgeThreshold)
		{
			drawPixel(x, y, painting);
			if (x > 0)
			{
				if (((jPanel1.C[x-1][y] == BFLPanel.NONE) && painting) ||
						((jPanel1.C[x-1][y] == jPanel1.color) && !painting))
				{
					edgeFill(x-1, y, painting);
				}
			}
			if (x<(PIC_WIDTH-1))
			{
				if (((jPanel1.C[x+1][y] == BFLPanel.NONE) && painting) ||
						((jPanel1.C[x+1][y] == jPanel1.color) && !painting))
				{
					edgeFill(x+1,y, painting);
				}
			}
			if (y>0)
			{
				if (((jPanel1.C[x][y-1] == BFLPanel.NONE) && painting) ||
						((jPanel1.C[x][y-1] == jPanel1.color) && !painting))
				{
					edgeFill(x, y-1, painting);
				}
			}
			if (y<(PIC_HEIGHT - 1))
			{
				if (((jPanel1.C[x][y+1] == BFLPanel.NONE) && painting) ||
						((jPanel1.C[x][y+1] == jPanel1.color) && !painting))
				{
					edgeFill(x, y+1, painting);
				}
			}
		}
	}


	//draws a line between lineX,lineY and x,y
	//start is used to set the starting point of the line
	/**
	 *  Description of the Method
	 *
	 * @param  x      Description of the Parameter
	 * @param  y      Description of the Parameter
	 * @param  start  Description of the Parameter
	 */
	void line(int x, int y, boolean start)
	{

		//initialise the starting point of the line
		if (start)
		{
			lineX = x;
			lineY = y;
			jTextArea1.setText("start " + Integer.toString(x) + ", " + Integer.toString(y));
		}
		else
		{

			jTextArea1.append("end " + Integer.toString(x) + ", " + Integer.toString(y));

			//if a start point hasnt been selected, return
			if (lineX == -1)
			{
				return;
			}

			//check whether the line should be based on X or Y
			if (Math.abs(y - lineY) < Math.abs(x - lineX))
			{

				double  m  = ((double) y - lineY) / ((double) x - lineX);
				double  b  = lineY - m * lineX;

				if (x > lineX)
				{
					int  temp  = x;
					x = lineX;
					lineX = temp;
				}

				for (double i = x; i <= lineX + 1; i += .1)
				{
					int  c  = (int) i;
					int  d  = (int) (m * i + b);
					drawPixel(c, d, true);
				}
			}
			else
			{

				double  m  = ((double) x - lineX) / ((double) y - lineY);
				double  b  = lineX - m * lineY;

				if (y > lineY)
				{
					int  temp  = y;
					y = lineY;
					lineY = temp;
				}

				for (double i = y; i <= lineY + 1; i += .1)
				{
					int  c  = (int) i;
					int  d  = (int) (m * i + b);
					drawPixel(d, c, true);
				}
			}

			//reset the starting points (-1 = no starting point selected)
			lineX = -1;
			lineY = -1;

		}
	}
}

