/*

Copyright 2003 The University of New South Wales (UNSW) and National  
ICT Australia (NICTA).

This file is part of the 2003 team rUNSWift RoboCup entry.  You may  
redistribute it and/or modify it under the terms of the GNU General  
Public License as published by the Free Software Foundation; either  
version 2 of the License, or (at your option) any later version as  
modified below.  As the original licensors, we add the following  
conditions to that license:

In paragraph 2.b), the phrase "distribute or publish" should be  
interpreted to include entry into a competition, and hence the source  
of any derived work entered into a competition must be made available  
to all parties involved in that competition under the terms of this  
license.

In addition, if the authors of a derived work publish any conference  
proceedings, journal articles or other academic papers describing that  
derived work, then appropriate academic citations to the original work  
must be included in that publication.

This rUNSWift source is distributed in the hope that it will be useful,  
but WITHOUT ANY WARRANTY; without even the implied warranty of  
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
General Public License for more details.

You should have received a copy of the GNU General Public License along  
with this source code; if not, write to the Free Software Foundation,  
Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/*
 * Last modification background information
 * $Id: ActionPro.h 1953 2003-08-21 03:51:39Z eileenm $
 *
 * Copyright (c) 2003 UNSW
 * All Rights Reserved.
 * 
 * Interface of the ActuatorControl object to call the responsible functions in PWalk and HeadMotion.
 *
**/

#ifndef _ActionPro_h_DEFINED
#define _ActionPro_h_DEFINED

#include "PWalk.h"
#include "HeadMotion.h"
#include "../share/Common.h"
#include "Indicators.h"
#include "../share/ActionProDef.h"
#include "../share/SwitchBoard.h"

class ActionPro {

public:
    ActionPro ();
    ~ActionPro () {
        delete(pAgent);
        delete(headAgent);
    }
    void SetPAgent (OSubject *sbjShmPWalk);
    
    void execute (const ONotifyEvent& event);
    void ContinueStep ();
	void initMem();

    AtomicAction next;
    bool takenFirstStep;
    
    PWalk      *pAgent;
    HeadMotion *headAgent;
    
    OSubject *sEffector, *sHead; 
    EffectorCommander eCommander;

    //seems like actionSuccess doesn't do anything
    //verify with the rest of the team then delete
    //int actionSuccess;

    int    *leading_leg; /* -1 = left, 1 = right, 0 = unknown */
    int    *currentWalkType;
	int    *shareStep_;
	int    *currentPG;
    double *desiredPan;
    double *desiredTilt;
    bool   *stepComplete;

private:
	RCRegion *shmPWalk; /* shared memory region for telling us what to do */

};

#endif // _ActionPro_h_DEFINED

