/*

Copyright 2003 The University of New South Wales (UNSW) and National  
ICT Australia (NICTA).

This file is part of the 2003 team rUNSWift RoboCup entry.  You may  
redistribute it and/or modify it under the terms of the GNU General  
Public License as published by the Free Software Foundation; either  
version 2 of the License, or (at your option) any later version as  
modified below.  As the original licensors, we add the following  
conditions to that license:

In paragraph 2.b), the phrase "distribute or publish" should be  
interpreted to include entry into a competition, and hence the source  
of any derived work entered into a competition must be made available  
to all parties involved in that competition under the terms of this  
license.

In addition, if the authors of a derived work publish any conference  
proceedings, journal articles or other academic papers describing that  
derived work, then appropriate academic citations to the original work  
must be included in that publication.

This rUNSWift source is distributed in the hope that it will be useful,  
but WITHOUT ANY WARRANTY; without even the implied warranty of  
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
General Public License for more details.

You should have received a copy of the GNU General Public License along  
with this source code; if not, write to the Free Software Foundation,  
Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#ifndef _primitives_h_DEFINED
#define _primitives_h_DEFINED

///////////////////
//   LEG STUFF   //
///////////////////

const PrimitiveIndex walkJoints[] = {

    HeadTilt,
    HeadPan,
    HeadRoll,
    FrontRightLeg1,
    FrontRightLeg2,
    FrontRightLeg3,
    FrontLeft1,
    FrontLeft2,
    FrontLeft3,
    RearRight1,
    RearRight2,
    RearRight3,
    RearLeft1,
    RearLeft2,
    RearLeft3
};

/*
const char *const Joint[] = {

    "PRM:/r1/c1-Joint2:j1",       // head tilt
    "PRM:/r1/c1/c2-Joint2:j2",    // head pan
    "PRM:/r1/c1/c2/c3-Joint2:j3", // head roll
    "PRM:/r4/c1-Joint2:j1",       // leg FR joint
    "PRM:/r4/c1/c2-Joint2:j2",    // leg FR shoulder
    "PRM:/r4/c1/c2/c3-Joint2:j3", // leg FR knee
    "PRM:/r2/c1-Joint2:j1",       // leg FL joint
    "PRM:/r2/c1/c2-Joint2:j2",    // leg FL shoulder
    "PRM:/r2/c1/c2/c3-Joint2:j3", // leg FL knee
    "PRM:/r5/c1-Joint2:j1",       // leg RR joint
    "PRM:/r5/c1/c2-Joint2:j2",    // leg RR shoulder
    "PRM:/r5/c1/c2/c3-Joint2:j3", // leg RR knee
    "PRM:/r3/c1-Joint2:j1",       // leg RL joint
    "PRM:/r3/c1/c2-Joint2:j2",    // leg RL shoulder
    "PRM:/r3/c1/c2/c3-Joint2:j3", // leg RL knee
};

const word Pid[][6] = {

    {0x0A, 0x08, 0x0C, 0x0E, 0x02, 0x0F}, // head tilt
    {0x0D, 0x08, 0x0B, 0x0E, 0x02, 0x0F}, // head pan
    {0x0C, 0x08, 0x0C, 0x0E, 0x02, 0x0F}, // head roll
    {0x16, 0x04, 0x08, 0x0E, 0x02, 0x0F}, // leg FR joint
    {0x14, 0x04, 0x06, 0x0E, 0x02, 0x0F}, // leg FR shoulder
    {0x23, 0x04, 0x05, 0x0E, 0x02, 0x0F}, // leg FR knee
    {0x16, 0x04, 0x08, 0x0E, 0x02, 0x0F}, // leg FL joint
    {0x14, 0x04, 0x06, 0x0E, 0x02, 0x0F}, // leg FL shoulder
    {0x23, 0x04, 0x05, 0x0E, 0x02, 0x0F}, // leg FL knee
    {0x16, 0x04, 0x08, 0x0E, 0x02, 0x0F}, // leg RR joint
    {0x14, 0x04, 0x06, 0x0E, 0x02, 0x0F}, // leg RR shoulder
    {0x23, 0x04, 0x05, 0x0E, 0x02, 0x0F}, // leg RR knee
    {0x16, 0x04, 0x08, 0x0E, 0x02, 0x0F}, // leg RL joint
    {0x14, 0x04, 0x06, 0x0E, 0x02, 0x0F}, // leg RL shoulder
    {0x23, 0x04, 0x05, 0x0E, 0x02, 0x0F}, // leg RL knee
};

*/

////////////////////
//   HEAD STUFF   //
////////////////////

const PrimitiveIndex headJoints[] = {
    HeadTilt, HeadPan, HeadRoll 
};

/*
const char *const HEAD_JOINT[] = {
    "PRM:/r1/c1-Joint2:j1",        // head tilt
    "PRM:/r1/c1/c2-Joint2:j2",     // head pan
    "PRM:/r1/c1/c2/c3-Joint2:j3",  // head roll
};
*/

#endif //_primitives_h_DEFINED
