/*

Copyright 2003 The University of New South Wales (UNSW) and National  
ICT Australia (NICTA).

This file is part of the 2003 team rUNSWift RoboCup entry.  You may  
redistribute it and/or modify it under the terms of the GNU General  
Public License as published by the Free Software Foundation; either  
version 2 of the License, or (at your option) any later version as  
modified below.  As the original licensors, we add the following  
conditions to that license:

In paragraph 2.b), the phrase "distribute or publish" should be  
interpreted to include entry into a competition, and hence the source  
of any derived work entered into a competition must be made available  
to all parties involved in that competition under the terms of this  
license.

In addition, if the authors of a derived work publish any conference  
proceedings, journal articles or other academic papers describing that  
derived work, then appropriate academic citations to the original work  
must be included in that publication.

This rUNSWift source is distributed in the hope that it will be useful,  
but WITHOUT ANY WARRANTY; without even the implied warranty of  
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
General Public License for more details.

You should have received a copy of the GNU General Public License along  
with this source code; if not, write to the Free Software Foundation,  
Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/*
 * Last modification background information
 * $Id: teamUtherCommon.h 1953 2003-08-21 03:51:39Z eileenm $
 *
 * Copyright (c) 2003 UNSW
 * All Rights Reserved.
 * 
**/

/*
 * This code is the sole property of Team Uther Lightbringer and the Silver Hand
 * Contains standard definitions and functions for team creations
**/ 

#ifndef _TeamUther_h_DEFINED
#define _TeamUther_h_DEFINED

#include "Behaviours.h"
/*
#include "teamB.h"
#include "teamC.h"
#include "teamD.h"
*/
//#include "maverick.h"

// bit masks for wireless behaviour communication
// from least to most significant bits
// 0   - goalie
// 1   - have ball
// 2,3 - forward positioning
static const int TU_GOALIE_MASK 	= 1;
static const int TU_HAVE_BALL_MASK  = 1 << 1;
static const int TU_ADVANCING_MASK  = 1 << 2;
static const int TU_SUPPORT_MASK    = 1 << 3;
static const int TU_SUPPLEFT_MASK   = 1 << 4;



// represents the status of a player
static const int TU_NOBODY 	= 0;
static const int TU_FORWARD	= 1;
static const int TU_GOALIE 	= 2;


// represents a relative value
static const int TU_ONLY_FORWARD = -2;
static const int TU_LEAST = -1;
static const int TU_MIDDLE = 0;
static const int TU_GREATEST = 1;

using namespace Behaviours;

namespace uther {

using Behaviours::left;

//using TeamB::goalieResetFindBallCounter;
//using Maverick::setGpsTrackBallHeadParams;
//using TeamD::teamDForwardFindBall;

/*
using TeamC::blockDistance;
using TeamC::blockSpeed;
using TeamC::blockAngle;
using TeamC::blockLength;
using TeamC::allowedAttackDist;
using TeamC::allowedAttackDem;
using TeamC::goalieLookAround;
*/
/*
using Maverick::blockDistance;
using Maverick::blockSpeed;
using Maverick::blockAngle;
using Maverick::blockLength;
using Maverick::allowedAttackDist;
using Maverick::allowedAttackDem;
*/
//using Maverick::goalieLookAround;


    extern double allowedAttackDist;
    extern double allowedAttackDem;

    extern double blockDistance;
    extern double blockSpeed;
    extern double blockAngle;
    extern int blockLength;

    ///////////////////////
    // MALAK THE AVENGER //
    ///////////////////////
  
    extern bool prevHaveBall; // true if attacker in previous frame

    extern void initMalakTheAvenger();
    extern void doMalakTheAvenger();
    extern void setMalakTheAvengerValues();
    extern void chooseMalakTheAvengerStrategy();
    extern void chooseMalakTheAvengerAttackBall();
    extern void chooseMalakTheAvengerShootStrategy();

    extern bool malakTheAvengerHaveBall();
    extern bool malakTheAvengerSupport();
    extern bool malakTheAvengerStriker();
    extern bool malakTheAvengerCanSeeTeammate();
    extern bool malakTheAvengerCanSeeTeammateWithinDist(double dist);
    extern bool malakTheAvengerGPSTeammateWithinDistOfBall(double dist);
    extern void malakTheAvengerOutsideEdgeKickApproach();
    extern void malakTheAvengerPawKick(int pawType);
    extern void malakTheAvengerDribble();
    extern double malakTheAvengerGetSmallestAngleBetweenBallTeammate();
    extern void malakTheAvengerGetNearBall(double xoffset, double yoffset);
	
	extern void malakGoalieAdvancing();
	extern void malakGoalieHasBall();
	extern void malakSupportForward();
    extern void malakStrikerForward();
    extern void malakWingForward();
    extern void malakNormalForward();

    extern bool malakTheAvengerBallInMiddleStrip();
    extern bool malakTheAvengerIsInMiddleStrip();
    extern bool malakNeedVisualBackoff();
    extern bool malakTeammateInFace();
	
	extern void trackCalcBall();
    extern void malakTheAvengerTrackBall();
    extern void malakTurnKick90();
    extern void malakTurnKick180();
    extern void malakClearKick();
    extern void malakClearPush();
    extern void malakSpinKick();
    extern void malakSetSpinKickParams();
	
	///////////////////////
	// Zann The Defender //
	///////////////////////
	
	extern void initZannTheDefender();
	extern void doZannTheDefender();
	extern void zannTheDefenderValues();
	extern void chooseZannTheDefenderStrategy();
	extern bool zannBallIsInBox();
	extern void zannLookAtBeaconAndGoToDefendPosition();
	extern void zannGoalieFullCircleFindBall();
	extern void zannGoalieSemiCircleFindBall();
	extern void zannGoalieHeadFindBall();
	extern bool zannGoalieAllowedToBlock();
	extern bool zannGoalieBallWithinBlockDistance();
	extern bool zannGoalieBallWithinAttackDistance();
	extern bool zannBallIsInCornerAreas();
	extern bool zannOpponentIsCloserToBall();
	extern bool zannGoalieBallWithinDangerDistance();
	extern bool zannAllowedToAttackBall();
	extern double zannGoalieDistanceFromHome();
	extern bool zannGoalieIsInGoalieBox();
	extern bool zannGoalieBallIsGoingToArriveAtYouSoon();
	extern void zannCalculateDefendPositionHeading(double *destx, double *desty, double *desth);
	extern bool zannHasReachedDefaultPosition();
	extern void zannGoToDefaultPositionHeading();
	extern void zannGoToDefendPositionHeading(double defendX, double defendY, double defendH);
	extern bool zannHasReachedDefendPositionHeading(double defendX, double defendY, double defendH);
	extern bool zannHasReachedDefendPositionHeadingWhenLookingForBall(double defendX, double defendY, double defendH);
	extern bool zannBallJumpedTooMuch();
	extern void zannSetGpsTrackBallHeadParams();
	extern void zannSetTrackBallHeadParams();
	extern void zannGoalieAttackGpsBall();
	extern void zannGoalieAttackBall();
	extern void zannGoalieHoverToBall(bool usingVision);
	extern void zannaaGoalieHoldBall();
	extern void zannGotBall();
	extern void zannFindBestGap(double minAllowedAngle, double maxAllowedAngle, double *returnMinAngle, double *returnMaxAngle);
    extern void zannUseWirelessBall();
    extern void zannCalculateDefendPositionHeadingWireless(double *destx, double *desty, double *desth);
    extern void zannTrackCalcBall();

    
	inline static int numInTeam(GPS *gps) {
	
		int ret = 1;
		for (int i=0 ; i<NUM_TEAM_MEMBER ; i++) {
			if (gps->tmObj(i).counter > 0)
				ret++;
		}
		return ret;
	
	}

	// Sets gps wireless communication to portray that this player is the goalie
	inline static void setGoalie(GPS *gps) {
	
		gps->sharedBehaviour() |= TU_GOALIE_MASK;
	
	}
	
	// Sets gps wireless communication to portray that this player has the ball
	inline static void setHaveBall(GPS *gps) {
	
		gps->sharedBehaviour() |= TU_HAVE_BALL_MASK;
	
	}

	// Sets gps wireless communication to portray that this player is support
	inline static void setSupport(GPS *gps) {
	
		gps->sharedBehaviour() |= TU_SUPPORT_MASK;
	
	}
	
	// Sets gps wireless communication to portray that this player is left support
	inline static void setLeftSupport(GPS *gps) {
	
		gps->sharedBehaviour() |= TU_SUPPLEFT_MASK;
	
	}
	
	
	// Sets gps wireless communication to portray that this player is advancing
	inline static void setAdvancing(GPS *gps) {
	
		gps->sharedBehaviour() |= TU_ADVANCING_MASK;
	
	}
	
	
	// analyzes friendly behaviour communication
	// return is according to player status's defined above
	// note - can be used as a boolean
	inline static int friendHaveBall(GPS *gps) {
	
		int ret = TU_NOBODY;
		for (int i=0 ; i<NUM_TEAM_MEMBER ; i++) {
			if (((gps->tmObj(i).behavioursVal & TU_HAVE_BALL_MASK) != 0) &&
				 gps->tmObj(i).counter > 0) {
				 
				if ((gps->tmObj(i).behavioursVal) & TU_GOALIE_MASK)
					ret = TU_GOALIE;
				else if (ret == TU_NOBODY)
					ret = TU_FORWARD;
			}
		}
		
		return ret;
	}
	
	// analyzes friendly behaviour communication
    // returns true if another friend is already a support
	inline static bool friendIsSupport(GPS *gps) {
	
		for (int i = 0; i < NUM_TEAM_MEMBER; i++) {
			if (((gps->tmObj(i).behavioursVal & TU_SUPPORT_MASK) != 0) &&
				gps->tmObj(i).counter > 0) {
                return true;
			}
		}
		return false;
	}

    // returns true if support intends to move to left of ball
	inline static bool friendIsLeftSupport(GPS *gps) {
	
		for (int i = 0; i < NUM_TEAM_MEMBER; i++) {
			if (((gps->tmObj(i).behavioursVal & TU_SUPPORT_MASK) != 0) &&
                ((gps->tmObj(i).behavioursVal & TU_SUPPLEFT_MASK) != 0) &&
				gps->tmObj(i).counter > 0) {
                return true;
			}
		}
		return false;
	}

	// returns true if there is a goalie advancing on the ball
	inline static bool goalieAdvancing(GPS *gps) {
	
		for (int i = 0; i < NUM_TEAM_MEMBER; i++) {
			
			if (((gps->tmObj(i).behavioursVal & TU_ADVANCING_MASK) != 0) &&
			    ((gps->tmObj(i).behavioursVal & TU_GOALIE_MASK) != 0) &&
				 gps->tmObj(i).counter > 0) 
				 
				 return true;
		}
		
		return false;
	}
	
	
	// returns true if there is a forward advancing on the ball
	inline static bool forwardAdvancing(GPS *gps) {
	
		for (int i = 0; i < NUM_TEAM_MEMBER; i++) {
			
			if (((gps->tmObj(i).behavioursVal & TU_ADVANCING_MASK) != 0) &&
			   ((gps->tmObj(i).behavioursVal & TU_GOALIE_MASK) == 0) &&
				 gps->tmObj(i).counter > 0)
				 
				 return true;
		}
		
		return false;
	}
	
	// returns your lateral positioning relative to other forwards
	inline static int lateralPosRel(GPS *gps) {
	
		int numGreater = 0;
		int numLess = 0;
		
		double x = gps->self().pos.x;
		for (int i = 0; i < NUM_TEAM_MEMBER; i++) {
			
			if (gps->tmObj(i).counter <= 0 || 
				(gps->tmObj(i).behavioursVal & TU_GOALIE_MASK) == 0) 
				continue;
					
			if (gps->tmObj(i).pos.x > x)
				numGreater++;
			else
				numLess++;
		
		}
		
		if (numGreater > 0) {
			if (numLess > 0)
				return TU_MIDDLE;
			else
				return TU_LEAST;
		} else if (numLess > 0)
			return TU_GREATEST;
		else
			return TU_ONLY_FORWARD;
	
	}

	// returns own forward positioning relative to other forward
    // note - this function is used to determine whether to become
    // a striker or a support, and hence ignores the attacker's position
	inline static int forwardPosRel(GPS *gps) {
	
		int numGreater = 0;
		int numLess = 0;
		
		double y = gps->self().pos.y;
		for (int i = 0; i < NUM_TEAM_MEMBER; i++) {
			
			if (gps->tmObj(i).counter <= 0 || 
				((gps->tmObj(i).behavioursVal & TU_GOALIE_MASK) == 0) ||
                ((gps->tmObj(i).behavioursVal & TU_HAVE_BALL_MASK) == 0)) 
				continue;
					
			if (gps->tmObj(i).pos.y > y)
				numGreater++;
			else
				numLess++;
		}
		
		if (numGreater > 0) {
			if (numLess > 0)
				return TU_MIDDLE;
			else
				return TU_LEAST;
		} else if (numLess > 0)
			return TU_GREATEST;
		else
			return TU_ONLY_FORWARD;
	}

    // returns true if you are the highest player number that 'has ball'
    // use this only if you satisfy all the other 'have ball' conditions
    // i.e. see uther::malakTheAvengerHaveBall()
    inline static bool highestPlayerHaveBall(GPS *gps) {

        // iterate through all players with a greater player number
        for (int i = PLAYER_NUMBER; i < NUM_TEAM_MEMBER; i++) {
            if (((gps->tmObj(i).behavioursVal & TU_HAVE_BALL_MASK) != 0) &&
				gps->tmObj(i).counter > 0) {
                return false;                
            }
        }
        return true;
    }            

    // returns true if you are the highest player number that 'supports'
    // use this only if you satisfy all the other 'support' conditions
    // i.e. see uther::malakTheAvengerSupport()
    inline static bool highestPlayerSupport(GPS *gps) {

        // iterate through all players with a greater player number
        for (int i = PLAYER_NUMBER; i < NUM_TEAM_MEMBER; i++) {
            if (((gps->tmObj(i).behavioursVal & TU_SUPPORT_MASK) != 0) &&
				gps->tmObj(i).counter > 0) {
                return false;
            }
        }
        return true;
    }            

    // the furthest robot from the ball becomes the striker
    inline static bool assumeWingStrikerRole(GPS *gps, double ballX, double ballY) {

        // calculate own distance to ball
        const Vector& own = gps->self().pos;
        double ownDistToBall = sqrt(SQUARE(ballX - own.x) + SQUARE(ballY - own.y));

        // find the teammate that is furthest from ball
        int teammateFurthestFromBallPlayer   = -1;
        double teammateFurthestFromBallDistance = -1;

        for (int i = 0; i < NUM_TEAM_MEMBER; i++) {

            // ignore goalie                
			if (gps->tmObj(i).counter <= 0 || 
				(gps->tmObj(i).behavioursVal & TU_GOALIE_MASK) != 0) 
				continue;

            // ignore yourself
            if (i == PLAYER_NUMBER - 1)
                continue;

            const Vector& teammate = gps->tmObj(i).pos;
            double teammateDist = sqrt(SQUARE(ballX - teammate.x) +
                SQUARE(ballY - teammate.y));
          

            if (teammateFurthestFromBallDistance < teammateDist) {
                teammateFurthestFromBallPlayer = i;
                teammateFurthestFromBallDistance = teammateDist;
            }
        }

        // if you're the only forward alive, don't become wing striker
        if (teammateFurthestFromBallPlayer == -1) {
            return false;
        }

        // if you're obviously furthest away from ball, become wing striker
        if (ownDistToBall - teammateFurthestFromBallDistance > 30) {
            return true;
        }

        // if you're obviously not furthest away from ball, don't become wing striker
        if (teammateFurthestFromBallDistance - ownDistToBall > 30) {
            return false;
        }

        //-----------------------------------------------------------------
        // you're not obviously furthest away from the ball
        //-----------------------------------------------------------------
        
        // calculate striker point
        const double STRIKER_ANGLE = 30;
        const double STRIKER_DIST  = 150;

	    double strikerX;
        double strikerY;

	    double angle;
    	double dist;

        if (ballX > FIELD_WIDTH/2.0) {

            // ball in right strip, move to left
            angle = HALF_CIRCLE - STRIKER_ANGLE;
            dist  = STRIKER_DIST;

        } else {

            // ball in left strip, move to right
            angle = STRIKER_ANGLE;
            dist  = STRIKER_DIST;
        }

	    strikerX = ballX + dist*cos(DEG2RAD(angle));
    	strikerY = ballY + dist*sin(DEG2RAD(angle));

        if (strikerY > FIELD_LENGTH*3/4) {
            strikerY = FIELD_LENGTH*3/4;
        }

        if (strikerY < FIELD_LENGTH/4) {
            strikerY = FIELD_LENGTH/4;
        }

        // obtain own distance to striker point
        double ownDistToStrikerPoint = sqrt(SQUARE(strikerX - own.x) + 
            SQUARE(strikerY - own.y));

        // obtain teammate's distance to striker point
        const Vector& teammateToCompareWith = 
            gps->tmObj(teammateFurthestFromBallPlayer).pos;

        double teammateDistToStrikerPoint = sqrt(SQUARE(strikerX - teammateToCompareWith.x) +
            SQUARE(strikerY - teammateToCompareWith.y));

        // if i'm closer to the striker point, become wing striker
        if (ownDistToStrikerPoint < teammateDistToStrikerPoint) {
            return true;
        } else {
            return false;
        }                
    }

    // forward that 'has ball' and is closest to ball assumes attack role
    inline static bool mostSuitableToAttack(GPS *gps, double ballX, double ballY) {

        // calculate own distance to ball
        const Vector& own = gps->self().pos;
        double ownDist = sqrt(SQUARE(ballX - own.x) + SQUARE(ballY - own.y));

        // calculate how much you are from upfield
        double ownAngle;
        if (own.y < FIELD_LENGTH/2.0) {
            ownAngle = ABS(NormalizeAngle_180(90 - gps->self().h));
        } else {
            ownAngle = ABS(gps->tGoal().pos.head);
        }

        for (int i = 0; i < NUM_TEAM_MEMBER; i++) {

            if (((gps->tmObj(i).behavioursVal & TU_HAVE_BALL_MASK) == 0) ||
                ((gps->tmObj(i).behavioursVal & TU_GOALIE_MASK) != 0) ||
				gps->tmObj(i).counter <= 0)
                continue;

            if (i == PLAYER_NUMBER - 1)
                continue;

            // calculate teammate distance to ball
            const Vector& teammateGlobal = gps->tmObj(i).pos;
            double teammateDist = sqrt(SQUARE(ballX - teammateGlobal.x) +
                SQUARE(ballY - teammateGlobal.y));

            // calculate how much teammate is from upfield
            double tGoalGlobalX = FIELD_WIDTH/2.0;
            double tGoalGlobalY = FIELD_LENGTH + WALL_THICKNESS;
            double teammateAngle;
            if (own.y < FIELD_LENGTH/2.0) {
                teammateAngle = ABS(NormalizeAngle_180(90 - gps->teammate(i+1, 'l').h));
            } else {
                teammateAngle = ABS(NormalizeAngle_180(getHeadingBetween(
                    teammateGlobal.x, teammateGlobal.y, tGoalGlobalX, tGoalGlobalY) -
                    gps->teammate(i+1, 'g').h));
            }

            if (ownDist > (teammateDist + 10))
                return false;

            if (ownAngle > (teammateAngle + 20) && ballY > own.y)
                return false;                    

        }
        return true;
    }
}

#endif // _TeamUther_h_DEFINED
