/*

Copyright 2003 The University of New South Wales (UNSW) and National  
ICT Australia (NICTA).

This file is part of the 2003 team rUNSWift RoboCup entry.  You may  
redistribute it and/or modify it under the terms of the GNU General  
Public License as published by the Free Software Foundation; either  
version 2 of the License, or (at your option) any later version as  
modified below.  As the original licensors, we add the following  
conditions to that license:

In paragraph 2.b), the phrase "distribute or publish" should be  
interpreted to include entry into a competition, and hence the source  
of any derived work entered into a competition must be made available  
to all parties involved in that competition under the terms of this  
license.

In addition, if the authors of a derived work publish any conference  
proceedings, journal articles or other academic papers describing that  
derived work, then appropriate academic citations to the original work  
must be included in that publication.

This rUNSWift source is distributed in the hope that it will be useful,  
but WITHOUT ANY WARRANTY; without even the implied warranty of  
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
General Public License for more details.

You should have received a copy of the GNU General Public License along  
with this source code; if not, write to the Free Software Foundation,  
Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/*
 * Copyright 2002,2003 Sony Corporation
 *
 * Permission to use, copy, modify, and redistribute this software is
 * hereby granted.
 *
 * This software is provided "as is" without warranty of any kind,
 * either expressed or implied, including but not limited to the
 * implied warranties of fitness for a particular purpose.
 */

#ifndef _RoboCupGameControlData_h_DEFINED
#define _RoboCupGameControlData_h_DEFINED


#ifdef __cplusplus
extern "C" {
#endif


/* State */

typedef char RState;
const RState ROBOCUP_STATE_INITIAL      = 0x01; /* initial state             */
const RState ROBOCUP_STATE_READY        = 0x02; /* return to position and wait*/
const RState ROBOCUP_STATE_PLAYING      = 0x03; /* play game                 */
const RState ROBOCUP_STATE_PENALIZED    = 0x04; /* stop by penalty           */
const RState ROBOCUP_STATE_FINISH       = 0x05; /* game set                  */
const RState ROBOCUP_STATE_FINAL        = 0x05; /* game set (for compat.)    */


/* Kickoff */

typedef char RKickOff;
const RKickOff ROBOCUP_KICKOFF_OWN      = 0x01;
const RKickOff ROBOCUP_KICKOFF_OPPONENT = 0x02;
const RKickOff ROBOCUP_KICKOFF_INVALID  = 0x03;


/* Penalty */

const int NUM_PENALTY = 5;

const int PENALTY_INDEX_ILLEGAL_DEFENDER = 0;
const int PENALTY_INDEX_OBSTRUCTION      = 1;
const int PENALTY_INDEX_KEEPER_CHARGE    = 2;
const int PENALTY_INDEX_BALL_HOLDING     = 3;
const int PENALTY_INDEX_REQ_FOR_PICKUP   = 4;


/* Data type definition */

typedef struct {
    RState      state;                  /* state of player        */
    RKickOff    kickoff;                /* kickoff information    */
    short       ownScore;               /* score of own team      */
    short       opponentScore;          /* score of opponent team */
    char        penalty[NUM_PENALTY];   /* number of each penalty */
} RoboCupGameControlData;


#ifdef __cplusplus
}
#endif


#endif /* _RoboCupGameControlData_h_DEFINED */
