/*

Copyright 2003 The University of New South Wales (UNSW) and National  
ICT Australia (NICTA).

This file is part of the 2003 team rUNSWift RoboCup entry.  You may  
redistribute it and/or modify it under the terms of the GNU General  
Public License as published by the Free Software Foundation; either  
version 2 of the License, or (at your option) any later version as  
modified below.  As the original licensors, we add the following  
conditions to that license:

In paragraph 2.b), the phrase "distribute or publish" should be  
interpreted to include entry into a competition, and hence the source  
of any derived work entered into a competition must be made available  
to all parties involved in that competition under the terms of this  
license.

In addition, if the authors of a derived work publish any conference  
proceedings, journal articles or other academic papers describing that  
derived work, then appropriate academic citations to the original work  
must be included in that publication.

This rUNSWift source is distributed in the hope that it will be useful,  
but WITHOUT ANY WARRANTY; without even the implied warranty of  
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  
General Public License for more details.

You should have received a copy of the GNU General Public License along  
with this source code; if not, write to the Free Software Foundation,  
Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/*
 * @author UNSW 2003 Robocup (Will Uther)
 *
 * Last modification background information
 * $Id: VisionDef.h 1953 2003-08-21 03:51:39Z eileenm $
 *
 * Copyright (c) 2003 UNSW
 * All Rights Reserved.
 * 
**/


#ifndef VisionDef_h_DEFINED
#define VisionDef_h_DEFINED

#include "SanityConstant.h"

// size of primitive types
static const int INT_BYTES              = 4;
static const int LONG_BYTES             = 4;
static const int INT_BITS               = INT_BYTES * 8;

// size of the cplane
static const int CPLANE_WIDTH           = 176;
static const int CPLANE_HEIGHT          = 144;
static const int CPLANE_SIZE            = CPLANE_WIDTH * CPLANE_HEIGHT;  // 25344
static const int COMPRESSED_CPLANE_SIZE = CPLANE_SIZE * 2; // the maximum size of the compressed cplane using run-length encoding

// size of the sensors
static const int NUM_SENSOR_COORDS      = 3;
static const int SENSOR_SIZE            = NUM_SENSOR_COORDS * LONG_BYTES;

// size of the sanity values
static const int NUM_SANITY_COORDS      = (SANITY_COUNT-1)/INT_BITS + 1;
static const int SANITY_SIZE            = NUM_SANITY_COORDS * INT_BYTES;

// size of objects
static const int NUM_OBJ                = 17;
static const int NUM_INT_COORDS         = 6;
static const int NUM_DOUBLE_COORDS      = 2;
static const int ONE_OBJ_SIZE           = NUM_INT_COORDS * INT_BYTES;
static const int OBJ_SIZE               = NUM_OBJ*ONE_OBJ_SIZE + INT_BYTES*NUM_DOUBLE_COORDS; // use integer to represent the double values

static const int YUVPLANE_SCALE         = 3;
static const int YUVPLANE_SIZE          = CPLANE_SIZE * YUVPLANE_SCALE;  // 76032 

static const int DEBUG_PLANES           = 3;
static const int DEBUG_SIZE             = CPLANE_SIZE * DEBUG_PLANES;    // 76032 

// size of gps
static const int GPS_SIZE		= 420;

#endif // VisionDef_h_DEFINED

